using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Threading;
using System.Runtime.InteropServices;


namespace PhidgetApplication
{
	namespace PhidgetMouse
	{
		
		public class MainForm : System.Windows.Forms.Form
		{
			#region GUIR|[lg̐錾

			private System.Windows.Forms.CheckBox checkBoxEvent;
			private System.Windows.Forms.Label label1;
			private System.Windows.Forms.NumericUpDown numericUpDownX;
			private System.Windows.Forms.NumericUpDown numericUpDownY;
			private System.Windows.Forms.Label label2;
			private System.Windows.Forms.NumericUpDown numericUpDownWheel;
			private System.Windows.Forms.Label label3;
			private System.Windows.Forms.GroupBox groupBoxMouse;
			private System.Windows.Forms.TabControl tabControl;
			private System.Windows.Forms.TabPage tabPageDebug;
			private System.Windows.Forms.CheckBox checkBoxMessage;
			private System.Windows.Forms.TextBox textBoxMessage;
			private System.Windows.Forms.GroupBox groupBox1;
			private System.Windows.Forms.Button buttonConnect;
			private System.Windows.Forms.Button buttonDisconnect;
			private System.Windows.Forms.GroupBox groupBoxNet;
			private System.Windows.Forms.NumericUpDown numericUpDownPort;
			private System.Windows.Forms.Label labelPort;
			private System.Windows.Forms.Label labelIp;
			private System.Windows.Forms.TextBox textBoxIp;
			private System.Windows.Forms.GroupBox groupBox2;
			private System.Windows.Forms.Label label11;
			private System.Windows.Forms.Label label7;
			private System.Windows.Forms.Label label4;
			private System.Windows.Forms.GroupBox groupBox3;
			private System.Windows.Forms.TabPage tabPageMain;
			private System.Windows.Forms.Label label5;
			private System.Windows.Forms.Label label6;
			private System.Windows.Forms.Label label8;
			private System.Windows.Forms.GroupBox groupBox4;
			private System.Windows.Forms.CheckBox checkBoxLeft;
			private System.Windows.Forms.CheckBox checkBoxCenter;
			private System.Windows.Forms.CheckBox checkBoxRight;
			private System.Windows.Forms.ComboBox comboBoxMapW;
			private System.Windows.Forms.ComboBox comboBoxMapY;
			private System.Windows.Forms.ComboBox comboBoxMapX;
			private System.Windows.Forms.ComboBox comboBoxMapRight;
			private System.Windows.Forms.ComboBox comboBoxMapCenter;
			private System.Windows.Forms.ComboBox comboBoxMapLeft;
			/// <summary>
			/// KvȃfUCiϐłB
			/// </summary>
			private System.ComponentModel.Container components = null;

			#endregion

			#region 萔/ϐ̐錾

			//eLXg{bNX̍ő\
			const int TEXTBOX_CNT_MAX = 10000;

			//eXbh̃C^[o
			const int RX_THREAD_INTERVAL = 1;
			const int MOVING_THREAD_INTERVAL = 20;
			const int WHEEL_THREAD_INTERVAL = 200;
			//
			const int MOUSE_ZERO_MIN = 400;
			const int MOUSE_ZERO_MAX = 500;
			const int MOUSE_RESOLUTION = 25;

			//PhidgetServer֐ڑ邽߂TCP Client
			TcpClient phidgetClient = null;

			//MXbh
			Thread rxThread = null;
			//}EXړCxg𐶐Xbh
			Thread movingThread = null;
			//}EXzC[Cxg𐶐Xbh
			Thread wheelThread = null;
			
			//}EXCxgp\̂̐錾
			MouseInput mi;
			MouseInput miMove;
			MouseInput miWheel;

			//}EXCxg(΍W)̎w͈0-65535
			//const int MOUSE_ABSOLUTE_MAX = 65535;
			//const int MOUSE_ABSOLUTE_MIN = 0;

			#endregion

			#region RXgN^/fXgN^
			public MainForm()
			{
				InitializeComponent();	
			}
			
			protected override void Dispose( bool disposing )
			{
				StopThreads();
				if(phidgetClient != null)
					phidgetClient.Close();

				if( disposing )
				{
					if (components != null) 
					{
						components.Dispose();
					}
				}
				base.Dispose( disposing );
			}
			#endregion

			#region PhidgetServer̐ڑƃXbhJn/~

			//PhidgetServerɐڑ
			public bool Connect(IPAddress ip, int port)
			{
				try
				{
					IPEndPoint ipEndPoint = new IPEndPoint(ip, port);
					phidgetClient = new TcpClient();
					phidgetClient.Connect(ipEndPoint);
					return true;
				}
				catch(Exception  ex)
				{
					PrintError(ex.ToString());
					return false;
				}
			}

			//ǂݎXbhJn
			public void StartThreads()
			{
				if(rxThread != null || movingThread != null || wheelThread != null)
				{
					StopThreads();
				}
			
				rxThread = new Thread(new ThreadStart(RxWorker));
				rxThread.Start();
				movingThread = new Thread(new ThreadStart(MovingWorker));
				movingThread.Start();
				wheelThread = new Thread(new ThreadStart(WheelWorker));
				wheelThread.Start();
				return;
			}

			//Xbh̒~
			public void StopThreads()
			{
				if(rxThread != null)
				{
					rxThread.Abort();
					rxThread = null;
				}
				if(movingThread != null)
				{
					movingThread.Abort();
					movingThread = null;
				}
				if(wheelThread !=null)
				{
					wheelThread.Abort();
					wheelThread = null;
				}

				return;
			}
		
			#endregion

			#region MXbhƉ/Cxg
			//bZ[W̎M
			public void RxWorker()
			{
				StreamReader reader = new StreamReader(phidgetClient.GetStream(),
					System.Text.Encoding.ASCII);
				try
				{
					while(true)
					{
						string line = reader.ReadLine();	
						PrintDebug(line);
						if(Parse(line))
						{
							if((mi.dwFlags & MOUSEEVENTF_MOVE) > 0)
							{
								UpdateComponent(mi);
								miMove = mi;

							}
							else if((mi.dwFlags & MOUSEEVENTF_WHEEL) > 0)
							{
								UpdateComponent(mi);
								miWheel = mi;
							}
							else
							{
								UpdateComponent(mi);
								if(checkBoxEvent.Checked)
									CreateMouseEvent(mi);
							}
						}						
						Thread.Sleep(RX_THREAD_INTERVAL);
					}
				}
				catch(ThreadAbortException ex)
				{
				}
				catch(Exception ex)
				{
					PrintError(ex.ToString());
				}
				finally
				{
					reader.Close();
				}
			}

			private bool Parse(string line)
			{
				string [] args = line.Split(",".ToCharArray());

				if(args[0] == "In" && args[1] == "InterfaceKit")
				{
					if(args[2] == "Analog")
					{
						int move = CalcMovement(int.Parse(args[4]), 
							MOUSE_ZERO_MIN, 
							MOUSE_ZERO_MAX, 
							MOUSE_RESOLUTION) ;

						if(args[3] == comboBoxMapX.Text)
						{
							mi.dwFlags = MOUSEEVENTF_MOVE; 
							mi.dx = -move ; 
						}
						else if(args[3] == comboBoxMapY.Text)
						{
							mi.dwFlags = MOUSEEVENTF_MOVE;
							mi.dy = -move; 
						}
						else if(args[3] == comboBoxMapW.Text)
						{
							mi.dwFlags = MOUSEEVENTF_WHEEL;
							mi.mouseData =  move;
						}

					}
					else if(args[2] == "Digital")
					{
						if(args[3] == comboBoxMapLeft.Text)
						{
							if(int.Parse(args[4]) == 1) 
								mi.dwFlags = MOUSEEVENTF_LEFTDOWN;
							else 
								mi.dwFlags = MOUSEEVENTF_LEFTUP;
						}
						else if(args[3] == comboBoxMapCenter.Text)
						{
							if(int.Parse(args[4]) == 1) 
								mi.dwFlags = MOUSEEVENTF_MIDDLEDOWN;
							else
								mi.dwFlags = MOUSEEVENTF_MIDDLEUP;
						}
						else if(args[3] == comboBoxMapRight.Text)
						{
							if(int.Parse(args[4]) == 1)
								mi.dwFlags = MOUSEEVENTF_RIGHTDOWN;
							else
								mi.dwFlags = MOUSEEVENTF_RIGHTUP;
						}

					}
				}
			
				if(mi.dwFlags != 0 )
					return true;
				else
					return false;
			}

			//Έړʂ̌vZ
			private int CalcMovement(int data, int min, int max, int resolution)
			{
				int result = 0;

				if(data > max)
					result = (int)((data - max) / (float)resolution);
				else if (data < min)
					result = -(int)((min - data) / (float)resolution);

				return result;
			}

			//}EXCxg𐶐
			private void CreateMouseEvent(MouseInput mi)
			{
				Input input = new Input();
				input.type = INPUT_MOUSE;
				input.mi = mi;
			
				Input []inputs = new Input[1];
				inputs[0] = input;
				int size = Marshal.SizeOf(input);
				SendInput(1,inputs,size);
				return;
			}

			//R|[lg̍XV
			private void UpdateComponent(MouseInput mi)
			{
				numericUpDownX.Value = mi.dx;
				numericUpDownY.Value = mi.dy;
				numericUpDownWheel.Value = mi.mouseData;
				
				if((mi.dwFlags & MOUSEEVENTF_LEFTDOWN) > 0)
					checkBoxLeft.Checked = true;
				else if((mi.dwFlags & MOUSEEVENTF_LEFTUP) > 0)
					checkBoxLeft.Checked = false;

				if((mi.dwFlags & MOUSEEVENTF_MIDDLEDOWN) > 0)
					checkBoxCenter.Checked = true;
				else if((mi.dwFlags & MOUSEEVENTF_MIDDLEUP) > 0)
					checkBoxCenter.Checked = false;

				if((mi.dwFlags & MOUSEEVENTF_RIGHTDOWN) > 0)
					checkBoxRight.Checked = true;
				else if((mi.dwFlags & MOUSEEVENTF_RIGHTUP) > 0)
					checkBoxRight.Checked = false;
			}
			#endregion

			#region }EXړ/zC[Cxgo͂Xbh

			//}EX̓𐶐Xbh
			void MovingWorker()
			{
				try
				{
					while(true)
					{
						if((miMove.dwFlags & MOUSEEVENTF_MOVE) > 0)
						{
							if(checkBoxEvent.Checked)
								CreateMouseEvent(miMove);
						}
						
						Thread.Sleep(MOVING_THREAD_INTERVAL);
					}
				}
				catch(ThreadAbortException ex)
				{

				}
				catch(Exception ex)
				{
					PrintError(ex.ToString());
				}
			}

			//}EXzC[Cxg𐶐Xbh
			void WheelWorker()
			{
				int sleepTime = WHEEL_THREAD_INTERVAL;
				int w = 0;
				try
				{
					while(true)
					{
						if((miWheel.dwFlags & MOUSEEVENTF_WHEEL) > 0)
						{
							if(checkBoxEvent.Checked)
							{	
								CreateMouseEvent(miWheel);	
							}
							w = miWheel.mouseData;
						}

						//XN[x̓Xbh~ԂŒ
						if(w != 0)
						{
							sleepTime = (int)(WHEEL_THREAD_INTERVAL / ((float)Math.Abs(w)));
						}
						else
						{
							sleepTime = WHEEL_THREAD_INTERVAL;
						}
						Thread.Sleep(sleepTime);
					}
				}
				catch(ThreadAbortException ex)
				{
				}
				catch(Exception ex)
				{
					PrintError(ex.ToString());
				}
			}
			#endregion

			#region Windows tH[ fUCiŐꂽR[h 
			/// <summary>
			/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
			/// R[h GfB^ŕύXȂłB
			/// </summary>
			private void InitializeComponent()
			{
				System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
				this.checkBoxEvent = new System.Windows.Forms.CheckBox();
				this.label1 = new System.Windows.Forms.Label();
				this.numericUpDownX = new System.Windows.Forms.NumericUpDown();
				this.numericUpDownY = new System.Windows.Forms.NumericUpDown();
				this.label2 = new System.Windows.Forms.Label();
				this.numericUpDownWheel = new System.Windows.Forms.NumericUpDown();
				this.label3 = new System.Windows.Forms.Label();
				this.checkBoxLeft = new System.Windows.Forms.CheckBox();
				this.checkBoxCenter = new System.Windows.Forms.CheckBox();
				this.checkBoxRight = new System.Windows.Forms.CheckBox();
				this.groupBoxMouse = new System.Windows.Forms.GroupBox();
				this.tabControl = new System.Windows.Forms.TabControl();
				this.tabPageMain = new System.Windows.Forms.TabPage();
				this.groupBox2 = new System.Windows.Forms.GroupBox();
				this.groupBox3 = new System.Windows.Forms.GroupBox();
				this.label5 = new System.Windows.Forms.Label();
				this.comboBoxMapRight = new System.Windows.Forms.ComboBox();
				this.label6 = new System.Windows.Forms.Label();
				this.comboBoxMapCenter = new System.Windows.Forms.ComboBox();
				this.label8 = new System.Windows.Forms.Label();
				this.comboBoxMapLeft = new System.Windows.Forms.ComboBox();
				this.groupBox4 = new System.Windows.Forms.GroupBox();
				this.comboBoxMapX = new System.Windows.Forms.ComboBox();
				this.label11 = new System.Windows.Forms.Label();
				this.comboBoxMapW = new System.Windows.Forms.ComboBox();
				this.label7 = new System.Windows.Forms.Label();
				this.comboBoxMapY = new System.Windows.Forms.ComboBox();
				this.label4 = new System.Windows.Forms.Label();
				this.tabPageDebug = new System.Windows.Forms.TabPage();
				this.checkBoxMessage = new System.Windows.Forms.CheckBox();
				this.textBoxMessage = new System.Windows.Forms.TextBox();
				this.groupBox1 = new System.Windows.Forms.GroupBox();
				this.buttonConnect = new System.Windows.Forms.Button();
				this.buttonDisconnect = new System.Windows.Forms.Button();
				this.groupBoxNet = new System.Windows.Forms.GroupBox();
				this.numericUpDownPort = new System.Windows.Forms.NumericUpDown();
				this.labelPort = new System.Windows.Forms.Label();
				this.labelIp = new System.Windows.Forms.Label();
				this.textBoxIp = new System.Windows.Forms.TextBox();
				((System.ComponentModel.ISupportInitialize)(this.numericUpDownX)).BeginInit();
				((System.ComponentModel.ISupportInitialize)(this.numericUpDownY)).BeginInit();
				((System.ComponentModel.ISupportInitialize)(this.numericUpDownWheel)).BeginInit();
				this.groupBoxMouse.SuspendLayout();
				this.tabControl.SuspendLayout();
				this.tabPageMain.SuspendLayout();
				this.groupBox2.SuspendLayout();
				this.groupBox3.SuspendLayout();
				this.groupBox4.SuspendLayout();
				this.tabPageDebug.SuspendLayout();
				this.groupBox1.SuspendLayout();
				this.groupBoxNet.SuspendLayout();
				((System.ComponentModel.ISupportInitialize)(this.numericUpDownPort)).BeginInit();
				this.SuspendLayout();
				// 
				// checkBoxEvent
				// 
				this.checkBoxEvent.Checked = true;
				this.checkBoxEvent.CheckState = System.Windows.Forms.CheckState.Checked;
				this.checkBoxEvent.Location = new System.Drawing.Point(16, 96);
				this.checkBoxEvent.Name = "checkBoxEvent";
				this.checkBoxEvent.Size = new System.Drawing.Size(152, 24);
				this.checkBoxEvent.TabIndex = 19;
				this.checkBoxEvent.Text = "}EXCxg𐶐";
				// 
				// label1
				// 
				this.label1.Location = new System.Drawing.Point(8, 24);
				this.label1.Name = "label1";
				this.label1.Size = new System.Drawing.Size(16, 16);
				this.label1.TabIndex = 20;
				this.label1.Text = "x:";
				// 
				// numericUpDownX
				// 
				this.numericUpDownX.Location = new System.Drawing.Point(24, 24);
				this.numericUpDownX.Maximum = new System.Decimal(new int[] {
																			   4096,
																			   0,
																			   0,
																			   0});
				this.numericUpDownX.Minimum = new System.Decimal(new int[] {
																			   4096,
																			   0,
																			   0,
																			   -2147483648});
				this.numericUpDownX.Name = "numericUpDownX";
				this.numericUpDownX.ReadOnly = true;
				this.numericUpDownX.Size = new System.Drawing.Size(56, 19);
				this.numericUpDownX.TabIndex = 21;
				// 
				// numericUpDownY
				// 
				this.numericUpDownY.Location = new System.Drawing.Point(104, 24);
				this.numericUpDownY.Maximum = new System.Decimal(new int[] {
																			   4096,
																			   0,
																			   0,
																			   0});
				this.numericUpDownY.Minimum = new System.Decimal(new int[] {
																			   4096,
																			   0,
																			   0,
																			   -2147483648});
				this.numericUpDownY.Name = "numericUpDownY";
				this.numericUpDownY.ReadOnly = true;
				this.numericUpDownY.Size = new System.Drawing.Size(56, 19);
				this.numericUpDownY.TabIndex = 23;
				// 
				// label2
				// 
				this.label2.Location = new System.Drawing.Point(88, 24);
				this.label2.Name = "label2";
				this.label2.Size = new System.Drawing.Size(16, 16);
				this.label2.TabIndex = 22;
				this.label2.Text = "y:";
				// 
				// numericUpDownWheel
				// 
				this.numericUpDownWheel.Location = new System.Drawing.Point(208, 24);
				this.numericUpDownWheel.Maximum = new System.Decimal(new int[] {
																				   4096,
																				   0,
																				   0,
																				   0});
				this.numericUpDownWheel.Minimum = new System.Decimal(new int[] {
																				   4096,
																				   0,
																				   0,
																				   -2147483648});
				this.numericUpDownWheel.Name = "numericUpDownWheel";
				this.numericUpDownWheel.ReadOnly = true;
				this.numericUpDownWheel.Size = new System.Drawing.Size(56, 19);
				this.numericUpDownWheel.TabIndex = 25;
				// 
				// label3
				// 
				this.label3.Location = new System.Drawing.Point(168, 24);
				this.label3.Name = "label3";
				this.label3.Size = new System.Drawing.Size(40, 16);
				this.label3.TabIndex = 24;
				this.label3.Text = "wheel:";
				// 
				// checkBoxLeft
				// 
				this.checkBoxLeft.Enabled = false;
				this.checkBoxLeft.Location = new System.Drawing.Point(8, 48);
				this.checkBoxLeft.Name = "checkBoxLeft";
				this.checkBoxLeft.Size = new System.Drawing.Size(72, 24);
				this.checkBoxLeft.TabIndex = 26;
				this.checkBoxLeft.Text = "NbN";
				// 
				// checkBoxCenter
				// 
				this.checkBoxCenter.Enabled = false;
				this.checkBoxCenter.Location = new System.Drawing.Point(96, 48);
				this.checkBoxCenter.Name = "checkBoxCenter";
				this.checkBoxCenter.Size = new System.Drawing.Size(72, 24);
				this.checkBoxCenter.TabIndex = 27;
				this.checkBoxCenter.Text = "NbN";
				// 
				// checkBoxRight
				// 
				this.checkBoxRight.Enabled = false;
				this.checkBoxRight.Location = new System.Drawing.Point(184, 48);
				this.checkBoxRight.Name = "checkBoxRight";
				this.checkBoxRight.Size = new System.Drawing.Size(72, 24);
				this.checkBoxRight.TabIndex = 28;
				this.checkBoxRight.Text = "ENbN";
				// 
				// groupBoxMouse
				// 
				this.groupBoxMouse.Controls.Add(this.numericUpDownX);
				this.groupBoxMouse.Controls.Add(this.checkBoxRight);
				this.groupBoxMouse.Controls.Add(this.label2);
				this.groupBoxMouse.Controls.Add(this.label3);
				this.groupBoxMouse.Controls.Add(this.label1);
				this.groupBoxMouse.Controls.Add(this.numericUpDownY);
				this.groupBoxMouse.Controls.Add(this.checkBoxCenter);
				this.groupBoxMouse.Controls.Add(this.checkBoxLeft);
				this.groupBoxMouse.Controls.Add(this.numericUpDownWheel);
				this.groupBoxMouse.Location = new System.Drawing.Point(8, 8);
				this.groupBoxMouse.Name = "groupBoxMouse";
				this.groupBoxMouse.Size = new System.Drawing.Size(280, 80);
				this.groupBoxMouse.TabIndex = 29;
				this.groupBoxMouse.TabStop = false;
				this.groupBoxMouse.Text = "}EX̏";
				// 
				// tabControl
				// 
				this.tabControl.Controls.Add(this.tabPageMain);
				this.tabControl.Controls.Add(this.tabPageDebug);
				this.tabControl.Location = new System.Drawing.Point(0, 120);
				this.tabControl.Name = "tabControl";
				this.tabControl.SelectedIndex = 0;
				this.tabControl.Size = new System.Drawing.Size(304, 288);
				this.tabControl.TabIndex = 30;
				// 
				// tabPageMain
				// 
				this.tabPageMain.Controls.Add(this.checkBoxEvent);
				this.tabPageMain.Controls.Add(this.groupBoxMouse);
				this.tabPageMain.Controls.Add(this.groupBox2);
				this.tabPageMain.Location = new System.Drawing.Point(4, 21);
				this.tabPageMain.Name = "tabPageMain";
				this.tabPageMain.Size = new System.Drawing.Size(296, 263);
				this.tabPageMain.TabIndex = 1;
				this.tabPageMain.Text = "C";
				// 
				// groupBox2
				// 
				this.groupBox2.Controls.Add(this.groupBox3);
				this.groupBox2.Controls.Add(this.groupBox4);
				this.groupBox2.Location = new System.Drawing.Point(8, 128);
				this.groupBox2.Name = "groupBox2";
				this.groupBox2.Size = new System.Drawing.Size(280, 112);
				this.groupBox2.TabIndex = 30;
				this.groupBox2.TabStop = false;
				this.groupBox2.Text = "|[g̃}bsO";
				// 
				// groupBox3
				// 
				this.groupBox3.Controls.Add(this.label5);
				this.groupBox3.Controls.Add(this.comboBoxMapRight);
				this.groupBox3.Controls.Add(this.label6);
				this.groupBox3.Controls.Add(this.comboBoxMapCenter);
				this.groupBox3.Controls.Add(this.label8);
				this.groupBox3.Controls.Add(this.comboBoxMapLeft);
				this.groupBox3.Location = new System.Drawing.Point(8, 64);
				this.groupBox3.Name = "groupBox3";
				this.groupBox3.Size = new System.Drawing.Size(264, 40);
				this.groupBox3.TabIndex = 31;
				this.groupBox3.TabStop = false;
				this.groupBox3.Text = "{^";
				// 
				// label5
				// 
				this.label5.Location = new System.Drawing.Point(184, 16);
				this.label5.Name = "label5";
				this.label5.Size = new System.Drawing.Size(20, 16);
				this.label5.TabIndex = 36;
				this.label5.Text = "E:";
				// 
				// comboBoxMapRight
				// 
				this.comboBoxMapRight.Items.AddRange(new object[] {
																	  "0",
																	  "1",
																	  "2",
																	  "3",
																	  "4",
																	  "5",
																	  "6",
																	  "7"});
				this.comboBoxMapRight.Location = new System.Drawing.Point(208, 16);
				this.comboBoxMapRight.Name = "comboBoxMapRight";
				this.comboBoxMapRight.Size = new System.Drawing.Size(48, 20);
				this.comboBoxMapRight.TabIndex = 35;
				this.comboBoxMapRight.Text = "3";
				// 
				// label6
				// 
				this.label6.Location = new System.Drawing.Point(96, 16);
				this.label6.Name = "label6";
				this.label6.Size = new System.Drawing.Size(24, 16);
				this.label6.TabIndex = 34;
				this.label6.Text = ":";
				// 
				// comboBoxMapCenter
				// 
				this.comboBoxMapCenter.Items.AddRange(new object[] {
																	   "0",
																	   "1",
																	   "2",
																	   "3",
																	   "4",
																	   "5",
																	   "6",
																	   "7"});
				this.comboBoxMapCenter.Location = new System.Drawing.Point(120, 16);
				this.comboBoxMapCenter.Name = "comboBoxMapCenter";
				this.comboBoxMapCenter.Size = new System.Drawing.Size(48, 20);
				this.comboBoxMapCenter.TabIndex = 33;
				this.comboBoxMapCenter.Text = "2";
				// 
				// label8
				// 
				this.label8.Location = new System.Drawing.Point(8, 16);
				this.label8.Name = "label8";
				this.label8.Size = new System.Drawing.Size(24, 16);
				this.label8.TabIndex = 32;
				this.label8.Text = ":";
				// 
				// comboBoxMapLeft
				// 
				this.comboBoxMapLeft.Items.AddRange(new object[] {
																	 "0",
																	 "1",
																	 "2",
																	 "3",
																	 "4",
																	 "5",
																	 "6",
																	 "7"});
				this.comboBoxMapLeft.Location = new System.Drawing.Point(32, 16);
				this.comboBoxMapLeft.Name = "comboBoxMapLeft";
				this.comboBoxMapLeft.Size = new System.Drawing.Size(48, 20);
				this.comboBoxMapLeft.TabIndex = 31;
				this.comboBoxMapLeft.Text = "1";
				// 
				// groupBox4
				// 
				this.groupBox4.Controls.Add(this.comboBoxMapX);
				this.groupBox4.Controls.Add(this.label11);
				this.groupBox4.Controls.Add(this.comboBoxMapW);
				this.groupBox4.Controls.Add(this.label7);
				this.groupBox4.Controls.Add(this.comboBoxMapY);
				this.groupBox4.Controls.Add(this.label4);
				this.groupBox4.Location = new System.Drawing.Point(8, 16);
				this.groupBox4.Name = "groupBox4";
				this.groupBox4.Size = new System.Drawing.Size(264, 40);
				this.groupBox4.TabIndex = 31;
				this.groupBox4.TabStop = false;
				this.groupBox4.Text = "ړ";
				// 
				// comboBoxMapX
				// 
				this.comboBoxMapX.Items.AddRange(new object[] {
																  "0",
																  "1",
																  "2",
																  "3",
																  "4",
																  "5",
																  "6",
																  "7"});
				this.comboBoxMapX.Location = new System.Drawing.Point(32, 16);
				this.comboBoxMapX.Name = "comboBoxMapX";
				this.comboBoxMapX.Size = new System.Drawing.Size(48, 20);
				this.comboBoxMapX.TabIndex = 0;
				this.comboBoxMapX.Text = "0";
				// 
				// label11
				// 
				this.label11.Location = new System.Drawing.Point(184, 16);
				this.label11.Name = "label11";
				this.label11.Size = new System.Drawing.Size(16, 16);
				this.label11.TabIndex = 30;
				this.label11.Text = "w:";
				// 
				// comboBoxMapW
				// 
				this.comboBoxMapW.Items.AddRange(new object[] {
																  "0",
																  "1",
																  "2",
																  "3",
																  "4",
																  "5",
																  "6",
																  "7"});
				this.comboBoxMapW.Location = new System.Drawing.Point(208, 16);
				this.comboBoxMapW.Name = "comboBoxMapW";
				this.comboBoxMapW.Size = new System.Drawing.Size(48, 20);
				this.comboBoxMapW.TabIndex = 28;
				this.comboBoxMapW.Text = "2";
				// 
				// label7
				// 
				this.label7.Location = new System.Drawing.Point(96, 16);
				this.label7.Name = "label7";
				this.label7.Size = new System.Drawing.Size(16, 16);
				this.label7.TabIndex = 25;
				this.label7.Text = "y:";
				// 
				// comboBoxMapY
				// 
				this.comboBoxMapY.Items.AddRange(new object[] {
																  "0",
																  "1",
																  "2",
																  "3",
																  "4",
																  "5",
																  "6",
																  "7"});
				this.comboBoxMapY.Location = new System.Drawing.Point(120, 16);
				this.comboBoxMapY.Name = "comboBoxMapY";
				this.comboBoxMapY.Size = new System.Drawing.Size(48, 20);
				this.comboBoxMapY.TabIndex = 23;
				this.comboBoxMapY.Text = "1";
				// 
				// label4
				// 
				this.label4.Location = new System.Drawing.Point(8, 16);
				this.label4.Name = "label4";
				this.label4.Size = new System.Drawing.Size(16, 16);
				this.label4.TabIndex = 21;
				this.label4.Text = "x:";
				// 
				// tabPageDebug
				// 
				this.tabPageDebug.Controls.Add(this.checkBoxMessage);
				this.tabPageDebug.Controls.Add(this.textBoxMessage);
				this.tabPageDebug.Location = new System.Drawing.Point(4, 21);
				this.tabPageDebug.Name = "tabPageDebug";
				this.tabPageDebug.Size = new System.Drawing.Size(296, 263);
				this.tabPageDebug.TabIndex = 2;
				this.tabPageDebug.Text = "fobO";
				this.tabPageDebug.Visible = false;
				// 
				// checkBoxMessage
				// 
				this.checkBoxMessage.Location = new System.Drawing.Point(24, 8);
				this.checkBoxMessage.Name = "checkBoxMessage";
				this.checkBoxMessage.Size = new System.Drawing.Size(168, 24);
				this.checkBoxMessage.TabIndex = 3;
				this.checkBoxMessage.Text = "fobObZ[W\";
				// 
				// textBoxMessage
				// 
				this.textBoxMessage.Location = new System.Drawing.Point(8, 32);
				this.textBoxMessage.Multiline = true;
				this.textBoxMessage.Name = "textBoxMessage";
				this.textBoxMessage.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
				this.textBoxMessage.Size = new System.Drawing.Size(280, 200);
				this.textBoxMessage.TabIndex = 2;
				this.textBoxMessage.Text = "";
				// 
				// groupBox1
				// 
				this.groupBox1.Controls.Add(this.buttonConnect);
				this.groupBox1.Controls.Add(this.buttonDisconnect);
				this.groupBox1.Location = new System.Drawing.Point(8, 8);
				this.groupBox1.Name = "groupBox1";
				this.groupBox1.Size = new System.Drawing.Size(288, 48);
				this.groupBox1.TabIndex = 34;
				this.groupBox1.TabStop = false;
				this.groupBox1.Text = "R}h";
				// 
				// buttonConnect
				// 
				this.buttonConnect.Location = new System.Drawing.Point(16, 16);
				this.buttonConnect.Name = "buttonConnect";
				this.buttonConnect.Size = new System.Drawing.Size(56, 23);
				this.buttonConnect.TabIndex = 17;
				this.buttonConnect.Text = "ڑ";
				this.buttonConnect.Click += new System.EventHandler(this.buttonConnect_Click);
				// 
				// buttonDisconnect
				// 
				this.buttonDisconnect.Enabled = false;
				this.buttonDisconnect.Location = new System.Drawing.Point(88, 16);
				this.buttonDisconnect.Name = "buttonDisconnect";
				this.buttonDisconnect.Size = new System.Drawing.Size(56, 23);
				this.buttonDisconnect.TabIndex = 18;
				this.buttonDisconnect.Text = "ؒf";
				this.buttonDisconnect.Click += new System.EventHandler(this.buttonDisconnect_Click);
				// 
				// groupBoxNet
				// 
				this.groupBoxNet.Controls.Add(this.numericUpDownPort);
				this.groupBoxNet.Controls.Add(this.labelPort);
				this.groupBoxNet.Controls.Add(this.labelIp);
				this.groupBoxNet.Controls.Add(this.textBoxIp);
				this.groupBoxNet.Location = new System.Drawing.Point(8, 64);
				this.groupBoxNet.Name = "groupBoxNet";
				this.groupBoxNet.Size = new System.Drawing.Size(288, 48);
				this.groupBoxNet.TabIndex = 33;
				this.groupBoxNet.TabStop = false;
				this.groupBoxNet.Text = "PhidgetServer̐ݒ";
				// 
				// numericUpDownPort
				// 
				this.numericUpDownPort.Location = new System.Drawing.Point(200, 16);
				this.numericUpDownPort.Maximum = new System.Decimal(new int[] {
																				  100000,
																				  0,
																				  0,
																				  0});
				this.numericUpDownPort.Name = "numericUpDownPort";
				this.numericUpDownPort.Size = new System.Drawing.Size(56, 19);
				this.numericUpDownPort.TabIndex = 16;
				this.numericUpDownPort.Value = new System.Decimal(new int[] {
																				4321,
																				0,
																				0,
																				0});
				// 
				// labelPort
				// 
				this.labelPort.Location = new System.Drawing.Point(152, 24);
				this.labelPort.Name = "labelPort";
				this.labelPort.Size = new System.Drawing.Size(40, 16);
				this.labelPort.TabIndex = 15;
				this.labelPort.Text = "|[g:";
				// 
				// labelIp
				// 
				this.labelIp.Location = new System.Drawing.Point(16, 24);
				this.labelIp.Name = "labelIp";
				this.labelIp.Size = new System.Drawing.Size(24, 16);
				this.labelIp.TabIndex = 14;
				this.labelIp.Text = "IP:";
				// 
				// textBoxIp
				// 
				this.textBoxIp.Location = new System.Drawing.Point(56, 16);
				this.textBoxIp.Name = "textBoxIp";
				this.textBoxIp.Size = new System.Drawing.Size(80, 19);
				this.textBoxIp.TabIndex = 13;
				this.textBoxIp.Text = "127.0.0.1";
				// 
				// MainForm
				// 
				this.AutoScaleBaseSize = new System.Drawing.Size(5, 12);
				this.ClientSize = new System.Drawing.Size(304, 382);
				this.Controls.Add(this.groupBox1);
				this.Controls.Add(this.groupBoxNet);
				this.Controls.Add(this.tabControl);
				this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
				this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
				this.Name = "MainForm";
				this.Text = "PhidgetMouse";
				((System.ComponentModel.ISupportInitialize)(this.numericUpDownX)).EndInit();
				((System.ComponentModel.ISupportInitialize)(this.numericUpDownY)).EndInit();
				((System.ComponentModel.ISupportInitialize)(this.numericUpDownWheel)).EndInit();
				this.groupBoxMouse.ResumeLayout(false);
				this.tabControl.ResumeLayout(false);
				this.tabPageMain.ResumeLayout(false);
				this.groupBox2.ResumeLayout(false);
				this.groupBox3.ResumeLayout(false);
				this.groupBox4.ResumeLayout(false);
				this.tabPageDebug.ResumeLayout(false);
				this.groupBox1.ResumeLayout(false);
				this.groupBoxNet.ResumeLayout(false);
				((System.ComponentModel.ISupportInitialize)(this.numericUpDownPort)).EndInit();
				this.ResumeLayout(false);

			}
			#endregion

			#region GUIR|[lg̃Cxg
			private void buttonConnect_Click(object sender, System.EventArgs e)
			{
				if(!Connect(IPAddress.Parse(textBoxIp.Text), (int)numericUpDownPort.Value))
					return;

				StartThreads();
				buttonConnect.Enabled = false;
				buttonDisconnect.Enabled = true;	
			}

			private void buttonDisconnect_Click(object sender, System.EventArgs e)
			{
				StopThreads();
				buttonConnect.Enabled = true;
				buttonDisconnect.Enabled = false;
			}
			#endregion

			#region bZ[W֘Ã\bh
			public void PrintMessage(string m, params object []args)
			{
				if(textBoxMessage.TextLength > TEXTBOX_CNT_MAX)
					textBoxMessage.Clear();
				textBoxMessage.Text = String.Format(m,args) + "\r\n" + textBoxMessage.Text;	
			}

			public void PrintDebug(string m, params object []args)
			{
				if(checkBoxMessage.Checked)
				{
					PrintMessage(m,args);
				}
			}

			public void PrintError(string m, params object []args)
			{
				PrintMessage("Error: " + m,args);
			}
			#endregion

			#region mouse_event֘ADLLImport/萔/\
					
			[DllImport("user32.dll", SetLastError=true)]
			static extern int mouse_event(int dwFlags, int dx, int dy, int dwData, int dwExtraInfo);

			[DllImport("user32.dll", SetLastError=true)]
			static extern int SendInput(uint nInputs, Input []pInputs, int cbSize);

			const int  MOUSEEVENTF_MOVE =		0x0001;
			const int  MOUSEEVENTF_LEFTDOWN =	0x0002;
			const int  MOUSEEVENTF_LEFTUP =		0x0004;
			const int  MOUSEEVENTF_RIGHTDOWN =	0x0008;
			const int  MOUSEEVENTF_RIGHTUP =	0x0010;
			const int  MOUSEEVENTF_MIDDLEDOWN = 0x0020;
			const int  MOUSEEVENTF_MIDDLEUP =	0x0040;
			const int  MOUSEEVENTF_ABSOLUTE =	0x8000;
			const int  MOUSEEVENTF_WHEEL =		0x0800;

			const int WHEEL_DELTA = 120;

			const int INPUT_MOUSE = 0x00;
			const int INPUT_KEYBOARD = 0x01;
			const int INPUT_HARDWARE = 0x02;


			[StructLayout(LayoutKind.Explicit)]
				struct Input 
			{
				[FieldOffset(0)]
				public int type;
				[FieldOffset(4)]
				public MouseInput mi;
				[FieldOffset(4)]
				public KeybdInput ki;
				[FieldOffset(4)]
				public HardwareInput hi;
			}

			struct MouseInput 
			{
				public int dx;
				public int dy;
				public int mouseData;
				public int dwFlags;
				public int time;
				public int dwExtraInfo;
			}

			struct KeybdInput
			{
				public short wVk;
				public short wScan;
				public int dwFlags;
				public int time;
				public int dwExtraInfo;
			}

			struct HardwareInput
			{
				public int uMsg;
				public short wParamL;
				public short wParamH;
			}
			#endregion


			[STAThread]
			static void Main() 
			{
				Application.Run(new MainForm());
			}

		}
	}
}
